import type { LiteralValue, SqlExpression, SqlRecord } from '../sql';
export interface FilterPatternDefinition<P> {
    name: string;
    fit(ex: SqlExpression): P | undefined;
    isValid(pattern: P): boolean;
    toExpression(pattern: P): SqlExpression;
    formatWithoutNegation(pattern: P): string;
    getColumn(pattern: P): string | undefined;
    getThing(pattern: P): string | undefined;
}
export declare function extractOuterNot(ex: SqlExpression): [boolean, SqlExpression];
export declare function sqlRecordGetLiteralValues(record: SqlRecord): LiteralValue[] | undefined;
export declare function castAsVarchar(ex: SqlExpression): SqlExpression;
export declare function unwrapCastAsVarchar(ex: SqlExpression): SqlExpression;
export declare function oneOf<T>(thing: T, ...options: T[]): boolean;
//# sourceMappingURL=common.d.ts.map