import { QueryResult } from '../query-result/query-result';
import { SqlQuery } from '../sql';
import { CancelToken } from './cancel-token';
export interface QueryParameter {
    type: string;
    value: string | number;
}
export interface DataAndHeaders {
    data: unknown;
    headers: Record<string, string>;
}
export declare type QueryExecutor = (payload: any, isSql: boolean, cancelToken?: CancelToken) => Promise<DataAndHeaders>;
export interface RunQueryOptions {
    query: string | SqlQuery | Record<string, any>;
    extraQueryContext?: Record<string, any>;
    queryParameters?: QueryParameter[];
    resultFormat?: string;
    header?: boolean;
    typesHeader?: boolean;
    sqlTypesHeader?: boolean;
    cancelToken?: CancelToken;
}
export declare type InflateDateStrategy = 'fromSqlTypes' | 'guess' | 'none';
export interface QueryRunnerOptions {
    executor?: QueryExecutor;
    inflateDateStrategy?: InflateDateStrategy;
}
export declare class QueryRunner {
    static defaultQueryExecutor?: QueryExecutor;
    static now(): number;
    static isEmptyContext(context: Record<string, any> | undefined): boolean;
    readonly executor?: QueryExecutor;
    readonly inflateDateStrategy: InflateDateStrategy;
    constructor(options?: QueryRunnerOptions);
    private getExecutor;
    runQuery(options: RunQueryOptions): Promise<QueryResult>;
}
//# sourceMappingURL=query-runner.d.ts.map