import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../sql-base';
import { SqlColumnList } from '../sql-column-list/sql-column-list';
import { SqlExpression } from '../sql-expression';
import { RefName } from '../utils';
export interface SqlAliasValue extends SqlBaseValue {
    expression: SqlExpression;
    alias: RefName;
    columns?: SqlColumnList;
}
export declare class SqlAlias extends SqlExpression {
    static type: SqlTypeDesignator;
    static DEFAULT_AS_KEYWORD: string;
    static create(expression: SqlExpression, alias: RefName | string, forceQuotes?: boolean): SqlAlias;
    readonly expression: SqlExpression;
    readonly alias: RefName;
    readonly columns?: SqlColumnList;
    constructor(options: SqlAliasValue);
    valueOf(): SqlAliasValue;
    protected _toRawString(): string;
    changeExpression(expression: SqlExpression): this;
    changeAlias(alias: string | RefName, forceQuotes?: boolean): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlExpression | undefined;
    ifUnnamedAliasAs(_alias: RefName | string, _forceQuotes?: boolean): SqlExpression;
    convertToTable(): SqlExpression;
    getAliasName(): string | undefined;
    getOutputName(): string | undefined;
    getUnderlyingExpression(): SqlExpression;
}
//# sourceMappingURL=sql-alias.d.ts.map