import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../sql-base';
import { SqlExpression } from '../sql-expression';
import { SeparatedArray } from '../utils';
export interface SqlWhenThenPartValue extends SqlBaseValue {
    whenExpressions: SeparatedArray<SqlExpression>;
    thenExpression: SqlExpression;
}
export declare class SqlWhenThenPart extends SqlBase {
    static type: SqlTypeDesignator;
    static DEFAULT_WHEN_KEYWORD: string;
    static DEFAULT_THEN_KEYWORD: string;
    static create(whenExpressions: SeparatedArray<SqlExpression> | SqlExpression[] | SqlExpression, thenExpression: SqlExpression): SqlWhenThenPart;
    readonly whenExpressions: SeparatedArray<SqlExpression>;
    readonly thenExpression: SqlExpression;
    constructor(options: SqlWhenThenPartValue);
    valueOf(): SqlWhenThenPartValue;
    protected _toRawString(): string;
    changeWhenExpressions(whenExpressions: SeparatedArray<SqlExpression> | SqlExpression[]): this;
    changeWhenExpression(whenExpression: SqlExpression): this;
    changeThenExpression(thenExpression: SqlExpression): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlBase | undefined;
}
//# sourceMappingURL=sql-when-then-part.d.ts.map