import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SqlType } from '../../sql-type/sql-type';
import { RefName } from '../../utils';
export interface SqlColumnDeclarationValue extends SqlBaseValue {
    column: RefName;
    columnType: SqlType;
}
export declare class SqlColumnDeclaration extends SqlBase {
    static type: SqlTypeDesignator;
    static create(column: string, columnType: string | SqlType): SqlColumnDeclaration;
    readonly column: RefName;
    readonly columnType: SqlType;
    constructor(options: SqlColumnDeclarationValue);
    valueOf(): SqlColumnDeclarationValue;
    protected _toRawString(): string;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlColumnDeclaration | undefined;
    getColumnName(): string;
    changeColumn(column: RefName | string): this;
    changeColumnType(columnType: SqlType | string): this;
}
//# sourceMappingURL=sql-column-declaration.d.ts.map