import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SqlExpression } from '../../sql-expression';
export declare type SqlJoinJoinTypeWithOn = 'LEFT' | 'RIGHT' | 'FULL' | 'INNER';
export declare type SqlJoinJoinType = SqlJoinJoinTypeWithOn | 'CROSS';
export interface SqlJoinPartValue extends SqlBaseValue {
    joinType?: SqlJoinJoinType;
    table: SqlExpression;
    onExpression?: SqlExpression;
}
export declare class SqlJoinPart extends SqlBase {
    static type: SqlTypeDesignator;
    static DEFAULT_JOIN_KEYWORD: string;
    static DEFAULT_ON_KEYWORD: string;
    static create(joinType: SqlJoinJoinTypeWithOn, table: SqlExpression, onExpression: SqlExpression | SqlExpression[]): SqlJoinPart;
    static cross(table: SqlExpression): SqlJoinPart;
    readonly joinType?: SqlJoinJoinType;
    readonly table: SqlExpression;
    readonly onExpression?: SqlExpression;
    constructor(options: SqlJoinPartValue);
    valueOf(): SqlJoinPartValue;
    protected _toRawString(): string;
    changeJoinTable(table: SqlExpression): this;
    changeOnExpression(onExpression: SqlExpression): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlBase | undefined;
}
//# sourceMappingURL=sql-join-part.d.ts.map