import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SqlExpression } from '../../sql-expression';
export declare type SqlOrderByDirection = 'ASC' | 'DESC';
export interface SqlOrderByExpressionValue extends SqlBaseValue {
    expression: SqlExpression;
    direction?: SqlOrderByDirection;
}
export declare class SqlOrderByExpression extends SqlBase {
    static type: SqlTypeDesignator;
    static create(expression: SqlExpression, direction?: SqlOrderByDirection): SqlOrderByExpression;
    static index(value: number, direction?: SqlOrderByDirection): SqlOrderByExpression;
    readonly expression: SqlExpression;
    readonly direction?: SqlOrderByDirection;
    constructor(options: SqlOrderByExpressionValue);
    valueOf(): SqlOrderByExpressionValue;
    protected _toRawString(): string;
    changeExpression(expression: SqlExpression): this;
    changeDirection(direction: SqlOrderByDirection | undefined): this;
    getEffectiveDirection(): SqlOrderByDirection;
    reverseDirection(): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlBase | undefined;
    isIndex(): boolean;
    getIndexValue(): number;
    incrementIndex(amount?: number): SqlOrderByExpression;
}
//# sourceMappingURL=sql-order-by-expression.d.ts.map