import { SqlBase, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SqlExpression } from '../../sql-expression';
import { SqlLiteral } from '../../sql-literal/sql-literal';
import { SqlClause, SqlClauseValue } from '../sql-clause';
export interface SqlPartitionedByClauseValue extends SqlClauseValue {
    expression?: SqlExpression;
}
export declare class SqlPartitionedByClause extends SqlClause {
    static type: SqlTypeDesignator;
    static DEFAULT_PARTITIONED_BY_KEYWORD: string;
    static DEFAULT_ALL_KEYWORD: string;
    static create(unit: SqlLiteral | undefined): SqlPartitionedByClause;
    readonly expression?: SqlExpression;
    constructor(options: SqlPartitionedByClauseValue);
    valueOf(): SqlPartitionedByClauseValue;
    protected _toRawString(): string;
    changePartitionedBy(expression: SqlExpression | undefined): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlClause | undefined;
}
//# sourceMappingURL=sql-partitioned-by-clause.d.ts.map