import { SqlBase, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SqlColumnList } from '../../sql-column-list/sql-column-list';
import { SqlExpression } from '../../sql-expression';
import { SqlTable } from '../../sql-table/sql-table';
import { SqlClause, SqlClauseValue } from '../sql-clause';
import { SqlWhereClause } from '../sql-where-clause/sql-where-clause';
export interface SqlReplaceClauseValue extends SqlClauseValue {
    table: SqlTable;
    columns?: SqlColumnList;
    whereClause?: SqlWhereClause;
}
export declare class SqlReplaceClause extends SqlClause {
    static type: SqlTypeDesignator;
    static readonly DEFAULT_REPLACE_KEYWORD = "REPLACE";
    static readonly DEFAULT_INTO_KEYWORD = "INTO";
    static readonly DEFAULT_OVERWRITE_KEYWORD = "OVERWRITE";
    static readonly DEFAULT_ALL_KEYWORD = "ALL";
    static create(table: SqlReplaceClause | SqlTable | string, where?: SqlWhereClause | SqlExpression): SqlReplaceClause;
    readonly table: SqlTable;
    readonly columns?: SqlColumnList;
    readonly whereClause?: SqlWhereClause;
    constructor(options: SqlReplaceClauseValue);
    valueOf(): SqlReplaceClauseValue;
    protected _toRawString(): string;
    changeTable(table: SqlTable | string): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlClause | undefined;
    changeWhereClause(whereClause: SqlWhereClause | undefined): this;
}
//# sourceMappingURL=sql-replace-clause.d.ts.map