import { SqlQuery, SqlValues } from '../..';
import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SqlColumnList } from '../../sql-column-list/sql-column-list';
import { RefName, SeparatedArray } from '../../utils';
export interface SqlWithPartValue extends SqlBaseValue {
    table: RefName;
    columns?: SqlColumnList;
    query: SqlQuery | SqlValues;
}
export declare class SqlWithPart extends SqlBase {
    static type: SqlTypeDesignator;
    static DEFAULT_AS_KEYWORD: string;
    static simple(name: string, query: SqlQuery): SqlWithPart;
    readonly table: RefName;
    readonly columns?: SqlColumnList;
    readonly query: SqlQuery | SqlValues;
    constructor(options: SqlWithPartValue);
    valueOf(): SqlWithPartValue;
    protected _toRawString(): string;
    changeTable(table: RefName): this;
    changeColumns(columns: SqlColumnList | SeparatedArray<RefName> | RefName[] | undefined): this;
    changeQuery(query: SqlQuery): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlBase | undefined;
}
//# sourceMappingURL=sql-with-part.d.ts.map