import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../sql-base';
import { SqlExpression } from '../sql-expression';
export interface SqlBetweenPartValue extends SqlBaseValue {
    symmetric?: boolean;
    start: SqlExpression;
    end: SqlExpression;
}
export declare class SqlBetweenPart extends SqlBase {
    static type: SqlTypeDesignator;
    static DEFAULT_SYMMETRIC_KEYWORD: string;
    static DEFAULT_AND_KEYWORD: string;
    static create(start: SqlExpression, end: SqlExpression): SqlBetweenPart;
    static symmetric(start: SqlExpression, end: SqlExpression): SqlBetweenPart;
    readonly symmetric?: boolean;
    readonly start: SqlExpression;
    readonly end: SqlExpression;
    constructor(options: SqlBetweenPartValue);
    valueOf(): SqlBetweenPartValue;
    protected _toRawString(): string;
    changeStart(start: SqlExpression): this;
    changeEnd(end: SqlExpression): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlBase | undefined;
}
//# sourceMappingURL=sql-between-part.d.ts.map