import { SqlBaseValue, SqlTypeDesignator } from '../sql-base';
import { SqlExpression } from '../sql-expression';
import { SqlFunction } from '../sql-function/sql-function';
import { LiteralValue } from '../sql-literal/sql-literal';
import { SqlTable } from '../sql-table/sql-table';
import { RefName } from '../utils';
export interface SqlNamespaceValue extends SqlBaseValue {
    refName: RefName;
}
export declare class SqlNamespace extends SqlExpression {
    static type: SqlTypeDesignator;
    static create(name: string | SqlNamespace): SqlNamespace;
    static optionalQuotes(name: string | SqlNamespace): SqlNamespace;
    readonly refName: RefName;
    constructor(options: SqlNamespaceValue);
    valueOf(): SqlNamespaceValue;
    protected _toRawString(): string;
    changeRefName(refName: RefName): this;
    getName(): string;
    changeName(name: string): this;
    prettyTrim(maxLength: number): this;
    table(name: string): SqlTable;
    tableWithOptionalQuotes(name: string): SqlTable;
    F(name: string, ...args: (SqlExpression | LiteralValue)[]): SqlFunction;
}
//# sourceMappingURL=sql-namespace.d.ts.map