import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../sql-base';
import { SqlExpression } from '../sql-expression';
import { LiteralValue } from '../sql-literal/sql-literal';
import { SeparatedArray } from '../utils';
export interface SqlRecordValue extends SqlBaseValue {
    expressions?: SeparatedArray<SqlExpression>;
}
export declare class SqlRecord extends SqlExpression {
    static type: SqlTypeDesignator;
    static DEFAULT_ROW_KEYWORD: string;
    static create(expressions?: SqlRecord | SeparatedArray<SqlExpression> | SqlExpression[]): SqlRecord;
    static createWithoutKeyword(expressions?: SqlRecord | SeparatedArray<SqlExpression> | SqlExpression[]): SqlRecord;
    readonly expressions?: SeparatedArray<SqlExpression>;
    constructor(options: SqlRecordValue);
    valueOf(): SqlRecordValue;
    protected _toRawString(): string;
    changeExpressions(expressions: SeparatedArray<SqlExpression> | SqlExpression[] | undefined): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlExpression | undefined;
    clearOwnSeparators(): this;
    prepend(expression: SqlExpression | LiteralValue): SqlRecord;
    append(expression: SqlExpression | LiteralValue): SqlRecord;
    unwrapIfSingleton(): SqlExpression;
}
//# sourceMappingURL=sql-record.d.ts.map