import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../sql-base';
import { SqlExpression } from '../sql-expression';
export declare type SqlUnaryOp = 'NOT' | '+' | '-';
export interface UnaryExpressionValue extends SqlBaseValue {
    op: SqlUnaryOp;
    argument: SqlExpression;
}
export declare class SqlUnary extends SqlExpression {
    static type: SqlTypeDesignator;
    static not(ex: SqlExpression): SqlUnary;
    readonly op: SqlUnaryOp;
    readonly argument: SqlExpression;
    constructor(options: UnaryExpressionValue);
    valueOf(): UnaryExpressionValue;
    protected _toRawString(): string;
    changeArgument(argument: SqlExpression): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlExpression | undefined;
    negate(): SqlExpression;
}
//# sourceMappingURL=sql-unary.d.ts.map