import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../sql-base';
import { SqlLimitClause, SqlOffsetClause, SqlOrderByClause, SqlOrderByExpression } from '../sql-clause';
import { SqlExpression } from '../sql-expression';
import { SqlLiteral } from '../sql-literal/sql-literal';
import { SqlRecord } from '../sql-record/sql-record';
import { SeparatedArray } from '../utils';
export interface SqlValuesValue extends SqlBaseValue {
    records: SeparatedArray<SqlRecord>;
    orderByClause?: SqlOrderByClause;
    limitClause?: SqlLimitClause;
    offsetClause?: SqlOffsetClause;
}
export declare class SqlValues extends SqlExpression {
    static type: SqlTypeDesignator;
    static DEFAULT_VALUES_KEYWORD: string;
    static create(records: SqlValues | SeparatedArray<SqlRecord> | SqlRecord[]): SqlValues;
    readonly records: SeparatedArray<SqlRecord>;
    readonly orderByClause?: SqlOrderByClause;
    readonly limitClause?: SqlLimitClause;
    readonly offsetClause?: SqlOffsetClause;
    constructor(options: SqlValuesValue);
    valueOf(): SqlValuesValue;
    protected _toRawString(): string;
    changeRecords(records: SeparatedArray<SqlRecord> | SqlRecord[]): this;
    changeOrderByClause(orderByClause: SqlOrderByClause | undefined): this;
    changeOrderByExpressions(orderByExpressions: SeparatedArray<SqlOrderByExpression> | SqlOrderByExpression[] | undefined): this;
    changeOrderByExpression(orderByExpression: SqlOrderByExpression | undefined): this;
    changeLimitClause(limitClause: SqlLimitClause | undefined): this;
    changeLimitValue(limitValue: SqlLiteral | number | undefined): this;
    changeOffsetClause(offsetClause: SqlOffsetClause | undefined): this;
    changeOffsetValue(offsetValue: SqlLiteral | number | undefined): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlExpression | undefined;
    clearOwnSeparators(): this;
}
//# sourceMappingURL=sql-values.d.ts.map