import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../sql-base';
import { SqlClusteredByClause, SqlInsertClause, SqlLimitClause, SqlOffsetClause, SqlOrderByClause, SqlOrderByExpression, SqlPartitionedByClause, SqlReplaceClause, SqlWithClause, SqlWithPart } from '../sql-clause';
import { SqlExpression } from '../sql-expression';
import { SqlLiteral } from '../sql-literal/sql-literal';
import { SqlQuery } from '../sql-query/sql-query';
import { SqlTable } from '../sql-table/sql-table';
import { SeparatedArray } from '../utils';
export interface SqlWithQueryValue extends SqlBaseValue {
    explain?: boolean;
    insertClause?: SqlInsertClause;
    replaceClause?: SqlReplaceClause;
    withClause: SqlWithClause;
    query: SqlQuery | SqlWithQuery;
    orderByClause?: SqlOrderByClause;
    limitClause?: SqlLimitClause;
    offsetClause?: SqlOffsetClause;
    partitionedByClause?: SqlPartitionedByClause;
    clusteredByClause?: SqlClusteredByClause;
}
export declare class SqlWithQuery extends SqlExpression {
    static type: SqlTypeDesignator;
    readonly explain?: boolean;
    readonly insertClause?: SqlInsertClause;
    readonly replaceClause?: SqlReplaceClause;
    readonly withClause: SqlWithClause;
    readonly query: SqlQuery | SqlWithQuery;
    readonly orderByClause?: SqlOrderByClause;
    readonly limitClause?: SqlLimitClause;
    readonly offsetClause?: SqlOffsetClause;
    readonly partitionedByClause?: SqlPartitionedByClause;
    readonly clusteredByClause?: SqlClusteredByClause;
    constructor(options: SqlWithQueryValue);
    valueOf(): SqlWithQueryValue;
    protected _toRawString(): string;
    changeExplain(explain: boolean): this;
    changeInsertClause(insertClause: SqlInsertClause | undefined): this;
    changeReplaceClause(replaceClause: SqlReplaceClause | undefined): this;
    changeWithClause(withClause: SqlWithClause): this;
    changeQuery(query: SqlQuery): this;
    changeOrderByClause(orderByClause: SqlOrderByClause | undefined): this;
    changeOrderByExpressions(orderByExpressions: SeparatedArray<SqlOrderByExpression> | SqlOrderByExpression[] | undefined): this;
    changeOrderByExpression(orderByExpression: SqlOrderByExpression | undefined): this;
    changeLimitClause(limitClause: SqlLimitClause | undefined): this;
    changeLimitValue(limitValue: SqlLiteral | number | undefined): this;
    changeOffsetClause(offsetClause: SqlOffsetClause | undefined): this;
    changeOffsetValue(offsetValue: SqlLiteral | number | undefined): this;
    changePartitionedByClause(partitionedByClause: SqlPartitionedByClause | undefined): this;
    changeClusteredByClause(clusteredByClause: SqlClusteredByClause | undefined): this;
    changeClusteredByExpressions(clusteredByExpressions: SeparatedArray<SqlExpression> | SqlExpression[] | undefined): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlWithQuery | undefined;
    makeExplain(): this;
    getInsertIntoTable(): SqlTable | undefined;
    changeInsertIntoTable(table: SqlTable | string | undefined): this;
    getReplaceIntoTable(): SqlTable | undefined;
    changeReplaceIntoTable(table: SqlTable | string | undefined): this;
    getIngestTable(): SqlTable | undefined;
    getWithParts(): readonly SqlWithPart[];
    changeWithParts(withParts: SeparatedArray<SqlWithPart> | SqlWithPart[]): this;
    prependWith(name: string, query: SqlQuery): this;
    flattenWith(): SqlQuery;
    hasOrderBy(): boolean;
    getOrderByExpressions(): readonly SqlOrderByExpression[];
    getOrderByForExpression(ex: SqlExpression): SqlOrderByExpression | undefined;
    addOrderBy(orderBy: SqlOrderByExpression): this;
    hasLimit(): boolean;
    hasOffset(): boolean;
}
//# sourceMappingURL=sql-with-query.d.ts.map